import{s as Ge,n as Ae,o as Oe}from"../chunks/scheduler.389d799c.js";import{S as Re,i as Ue,g as a,s,r as p,A as We,h as o,f as i,c as l,j as je,u as m,x as r,k as Fe,y as Be,a as n,v as f,d as u,t as c,w as g}from"../chunks/index.8f81d18f.js";import{H as d,E as Je}from"../chunks/EditOnGithub.33306dfe.js";function Ke(Ce){let h,W,R,B,v,J,$,be="Marching Cubes is an algorithm that converts a volumetric representation to a dense mesh.",K,x,Te='<img src="https://huggingface.co/datasets/dylanebert/ml-for-3d-course/resolve/main/torus.gif" alt="Torus Point Cloud"/>',N,C,we="<li><strong>Divide the Space into Voxels:</strong> Split the 3D space into a grid of voxels (cubic cells). The size of each voxel determines the mesh resolution.</li> <li><strong>Sample the Eight Vertex Positions:</strong> For each voxel, sample the density at the eight vertices (corners). Determine if each vertex is inside or outside the surface based on its density.</li> <li><strong>Determine the Triangle Configuration:</strong> Each voxel has eight vertices, each with two possible states (inside or outside), yielding 256 possible configurations. Each configuration corresponds to a specific triangulation pattern.</li>",Q,b,Me="Let’s walk through these steps in more detail.",X,T,Y,w,_e="The first step is to divide the 3D space into a grid of voxels. The size of each voxel will determine the resolution of the mesh.",Z,M,ee,_,ye="For each voxel, the algorithm samples the density at the eight vertices. Depending on the density, each vertex is classified as either <code>inside</code> or <code>outside</code> the surface.",te,y,ie,P,Pe="Each voxel’s eight vertices can be in two possible states, resulting in $2^8 = 256$ possible configurations. Each configuration corresponds to a specific triangulation pattern.",ne,L,Le='<img src="https://huggingface.co/datasets/dylanebert/ml-for-3d-course/resolve/main/MarchingCubesCases.png" alt="Marching Cubes Lookup"/>',se,H,le,E,He="To generate the final mesh, the algorithm “marches” through each voxel and applies the corresponding triangle configuration, hence the name “Marching Cubes”.",ae,k,Ee='<img src="https://huggingface.co/datasets/dylanebert/ml-for-3d-course/resolve/main/Marchingcubes-head.png" alt="Marching Cubes Head"/>',oe,D,ke="This process produces a dense, rough mesh that approximates the surface of the volume.",re,S,he,q,De="While useful for visualization, Marching Cubes meshes are mostly unsuitable for productions like games due to several limiting factors:",pe,z,Se="<li><strong>Polygon Count:</strong> High polygon meshes require more computation for rendering, which can significantly impact performance in real-time applications.</li> <li><strong>Edge Flow:</strong> Poor edge flow affects how the mesh deforms when animated, resulting in undesirable artifacts like creasing and pinching.</li> <li><strong>Texturing:</strong> The dense and irregular topology complicates UV mapping and texturing, resulting in texture artifacts.</li>",me,V,qe='<img src="https://huggingface.co/datasets/dylanebert/ml-for-3d-course/resolve/main/topology.jpg" alt="Mesh Topology"/>',fe,I,ue,j,ze='Techniques like <a href="https://research.nvidia.com/labs/toronto-ai/flexicubes/" rel="nofollow">FlexiCubes</a> address some limitations by allowing the mesh vertices to move, creating smoother surfaces. This approach is used by <a href="https://huggingface.co/spaces/TencentARC/InstantMesh" rel="nofollow">InstantMesh</a>, the current <a href="https://huggingface.co/spaces/dylanebert/3d-arena" rel="nofollow">leading</a> open-source 3D pipeline. However, the resulting meshes remain overly dense and impractical for production.',ce,F,ge,G,Ve="Cleaning up the topology of Marching Cubes output often requires more time and effort than creating a mesh from scratch. This creates a major bottleneck for ML for 3D applications. Gaussian Splatting, as discussed earlier, offers a potential solution to this bottleneck.",de,A,Ie="However, recent work has emerged that directly addresses this bottleneck, using differentiable techniques to produce low-poly meshes with higher-quality topology. This will be covered in the next section.",ve,O,$e,U,xe;return v=new d({props:{title:"Marching Cubes",local:"marching-cubes",headingTag:"h1"}}),T=new d({props:{title:"1. Divide the Space into Voxels",local:"1-divide-the-space-into-voxels",headingTag:"h3"}}),M=new d({props:{title:"2. Sample the Eight Vertex Positions",local:"2-sample-the-eight-vertex-positions",headingTag:"h3"}}),y=new d({props:{title:"3. Determine the Triangle Configuration",local:"3-determine-the-triangle-configuration",headingTag:"h3"}}),H=new d({props:{title:"4. Generate the Mesh",local:"4-generate-the-mesh",headingTag:"h3"}}),S=new d({props:{title:"Limitations",local:"limitations",headingTag:"h2"}}),I=new d({props:{title:"Improvements",local:"improvements",headingTag:"h3"}}),F=new d({props:{title:"In Practice",local:"in-practice",headingTag:"h2"}}),O=new Je({props:{source:"https://github.com/huggingface/ml-for-3d-course/blob/main/units/en/unit4/marching-cubes.mdx"}}),{c(){h=a("meta"),W=s(),R=a("p"),B=s(),p(v.$$.fragment),J=s(),$=a("p"),$.textContent=be,K=s(),x=a("p"),x.innerHTML=Te,N=s(),C=a("ol"),C.innerHTML=we,Q=s(),b=a("p"),b.textContent=Me,X=s(),p(T.$$.fragment),Y=s(),w=a("p"),w.textContent=_e,Z=s(),p(M.$$.fragment),ee=s(),_=a("p"),_.innerHTML=ye,te=s(),p(y.$$.fragment),ie=s(),P=a("p"),P.textContent=Pe,ne=s(),L=a("p"),L.innerHTML=Le,se=s(),p(H.$$.fragment),le=s(),E=a("p"),E.textContent=He,ae=s(),k=a("p"),k.innerHTML=Ee,oe=s(),D=a("p"),D.textContent=ke,re=s(),p(S.$$.fragment),he=s(),q=a("p"),q.textContent=De,pe=s(),z=a("ol"),z.innerHTML=Se,me=s(),V=a("p"),V.innerHTML=qe,fe=s(),p(I.$$.fragment),ue=s(),j=a("p"),j.innerHTML=ze,ce=s(),p(F.$$.fragment),ge=s(),G=a("p"),G.textContent=Ve,de=s(),A=a("p"),A.textContent=Ie,ve=s(),p(O.$$.fragment),$e=s(),U=a("p"),this.h()},l(e){const t=We("svelte-u9bgzb",document.head);h=o(t,"META",{name:!0,content:!0}),t.forEach(i),W=l(e),R=o(e,"P",{}),je(R).forEach(i),B=l(e),m(v.$$.fragment,e),J=l(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-13ifwrs"&&($.textContent=be),K=l(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-c3k4ef"&&(x.innerHTML=Te),N=l(e),C=o(e,"OL",{"data-svelte-h":!0}),r(C)!=="svelte-1bziwln"&&(C.innerHTML=we),Q=l(e),b=o(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-803f6m"&&(b.textContent=Me),X=l(e),m(T.$$.fragment,e),Y=l(e),w=o(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-zhxncx"&&(w.textContent=_e),Z=l(e),m(M.$$.fragment,e),ee=l(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-k3mdej"&&(_.innerHTML=ye),te=l(e),m(y.$$.fragment,e),ie=l(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-1qs09bu"&&(P.textContent=Pe),ne=l(e),L=o(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-19cgpgq"&&(L.innerHTML=Le),se=l(e),m(H.$$.fragment,e),le=l(e),E=o(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-15zs1c0"&&(E.textContent=He),ae=l(e),k=o(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-zw369q"&&(k.innerHTML=Ee),oe=l(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1k6o10e"&&(D.textContent=ke),re=l(e),m(S.$$.fragment,e),he=l(e),q=o(e,"P",{"data-svelte-h":!0}),r(q)!=="svelte-w9h4zv"&&(q.textContent=De),pe=l(e),z=o(e,"OL",{"data-svelte-h":!0}),r(z)!=="svelte-1xa3oq0"&&(z.innerHTML=Se),me=l(e),V=o(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-1a8714s"&&(V.innerHTML=qe),fe=l(e),m(I.$$.fragment,e),ue=l(e),j=o(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-1s9uoal"&&(j.innerHTML=ze),ce=l(e),m(F.$$.fragment,e),ge=l(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-ny4v8e"&&(G.textContent=Ve),de=l(e),A=o(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1u07c2s"&&(A.textContent=Ie),ve=l(e),m(O.$$.fragment,e),$e=l(e),U=o(e,"P",{}),je(U).forEach(i),this.h()},h(){Fe(h,"name","hf:doc:metadata"),Fe(h,"content",Ne)},m(e,t){Be(document.head,h),n(e,W,t),n(e,R,t),n(e,B,t),f(v,e,t),n(e,J,t),n(e,$,t),n(e,K,t),n(e,x,t),n(e,N,t),n(e,C,t),n(e,Q,t),n(e,b,t),n(e,X,t),f(T,e,t),n(e,Y,t),n(e,w,t),n(e,Z,t),f(M,e,t),n(e,ee,t),n(e,_,t),n(e,te,t),f(y,e,t),n(e,ie,t),n(e,P,t),n(e,ne,t),n(e,L,t),n(e,se,t),f(H,e,t),n(e,le,t),n(e,E,t),n(e,ae,t),n(e,k,t),n(e,oe,t),n(e,D,t),n(e,re,t),f(S,e,t),n(e,he,t),n(e,q,t),n(e,pe,t),n(e,z,t),n(e,me,t),n(e,V,t),n(e,fe,t),f(I,e,t),n(e,ue,t),n(e,j,t),n(e,ce,t),f(F,e,t),n(e,ge,t),n(e,G,t),n(e,de,t),n(e,A,t),n(e,ve,t),f(O,e,t),n(e,$e,t),n(e,U,t),xe=!0},p:Ae,i(e){xe||(u(v.$$.fragment,e),u(T.$$.fragment,e),u(M.$$.fragment,e),u(y.$$.fragment,e),u(H.$$.fragment,e),u(S.$$.fragment,e),u(I.$$.fragment,e),u(F.$$.fragment,e),u(O.$$.fragment,e),xe=!0)},o(e){c(v.$$.fragment,e),c(T.$$.fragment,e),c(M.$$.fragment,e),c(y.$$.fragment,e),c(H.$$.fragment,e),c(S.$$.fragment,e),c(I.$$.fragment,e),c(F.$$.fragment,e),c(O.$$.fragment,e),xe=!1},d(e){e&&(i(W),i(R),i(B),i(J),i($),i(K),i(x),i(N),i(C),i(Q),i(b),i(X),i(Y),i(w),i(Z),i(ee),i(_),i(te),i(ie),i(P),i(ne),i(L),i(se),i(le),i(E),i(ae),i(k),i(oe),i(D),i(re),i(he),i(q),i(pe),i(z),i(me),i(V),i(fe),i(ue),i(j),i(ce),i(ge),i(G),i(de),i(A),i(ve),i($e),i(U)),i(h),g(v,e),g(T,e),g(M,e),g(y,e),g(H,e),g(S,e),g(I,e),g(F,e),g(O,e)}}}const Ne='{"title":"Marching Cubes","local":"marching-cubes","sections":[{"title":"1. Divide the Space into Voxels","local":"1-divide-the-space-into-voxels","sections":[],"depth":3},{"title":"2. Sample the Eight Vertex Positions","local":"2-sample-the-eight-vertex-positions","sections":[],"depth":3},{"title":"3. Determine the Triangle Configuration","local":"3-determine-the-triangle-configuration","sections":[],"depth":3},{"title":"4. Generate the Mesh","local":"4-generate-the-mesh","sections":[],"depth":3},{"title":"Limitations","local":"limitations","sections":[{"title":"Improvements","local":"improvements","sections":[],"depth":3}],"depth":2},{"title":"In Practice","local":"in-practice","sections":[],"depth":2}],"depth":1}';function Qe(Ce){return Oe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class et extends Re{constructor(h){super(),Ue(this,h,Qe,Ke,Ge,{})}}export{et as component};
